clear all
close all
clc

run('elementdata_turbin');
%run('test_cantbeam');

soil =1 ;

E = 210e9;
nu = 0.3;
G = E/(2*(1+nu));
nac_weight = 476002; % total weight of nacelle rotor and blades

M = zeros(3*(num_el+1),3*(num_el+1));
K = zeros(3*(num_el+1),3*(num_el+1));

j = 1;

for i = 1:num_el


k_e = zeros(6,6);
m_e = zeros(6,6);



k_e(1,1) = A(i)*E/lel(i);
k_e(1,4) = -k_e(1,1);
k_e(2,2) = 12*E*I(i)/lel(i)^3;
k_e(2,3) = 6*E*I(i)/lel(i)^2;
k_e(2,5) = -12*E*I(i)/lel(i)^3;
k_e(2,6) = k_e(2,3);
k_e(3,2) = k_e(2,3);
k_e(3,3) = 4*E*I(i)/lel(i);
k_e(3,5) = -k_e(2,6);
k_e(3,6) = 2*E*I(i)/lel(i);
k_e(4,1) = k_e(1,4);
k_e(4,4) = k_e(1,1);
k_e(5,2) = -12*E*I(i)/lel(i)^3;
k_e(5,3) = -6*E*I(i)/lel(i)^2;
k_e(5,5) = 12*E*I(i)/lel(i)^3;
k_e(5,6) = k_e(5,3);
k_e(6,2)= -k_e(5,3);
k_e(6,3) = 2*E*I(i)/lel(i);
k_e(6,5) = k_e(5,6);
k_e(6,6) = 4*E*I(i)/lel(i);




% Adjusting stiffness matrix to include geometric effects from nacelle
% weight (decreased stiffness) 

k_g = zeros(6,6);
k_g(2,2) = 36; k_g(2,3) = 3*lel(i);
k_g(2,5) = -36; k_g(2,6) = 3*lel(i);
k_g(3,2) =3*lel(i) ; k_g(3,3)=4*lel(i)^2; 
k_g(3,5) =-3*lel(i); k_g(3,6) =-lel(i)^2 ;
k_g(5,2)=-36; k_g(5,3)=-3*lel(i); k_g(5,5)=36; k_g(5,6)=-3*lel(i);
k_g(6,2) = 3*lel(i); k_g(6,3) = -lel(i)^2; k_g(6,5) = -3*lel(i); 
k_g(6,6) = 4*lel(i)^2;
k_g = -(nac_weight*9.81/lel(i))*k_g; % negative because of compression force.


k_e = (k_e + k_g);

m_e(1,1) = 140;
m_e(1,4) = 70;
m_e(2,2) = 156;
m_e(2,3) = 22*lel(i);
m_e(2,5) = 54;
m_e(2,6) = -13*lel(i);
m_e(3,2) = m_e(2,3);
m_e(3,3) = 4*lel(i)^2;
m_e(3,5) = 13*lel(i);
m_e(3,6) = -3*lel(i)^2;
m_e(4,1) = 70;
m_e(4,4) = 140;
m_e(5,2) = 54;
m_e(5,3) = 13*lel(i);
m_e(5,5) = 156;
m_e(5,6) = -22*lel(i);
m_e(6,2) = -13*lel(i);
m_e(6,3) = -3*lel(i)^2;
m_e(6,5) = -22*lel(i);
m_e(6,6) = 4*lel(i)^2;


m_e = (el_mass(i)*lel(i)/420)*m_e;


%% Global assembly
K(j:(j+5),j:(j+5)) = K(j:(j+5),j:(j+5)) + k_e;
M(j:(j+5),j:(j+5)) = M(j:(j+5),j:(j+5)) + m_e;



j = j + 3;


end



%% ADDING nacelle weight to end node.
  M(end-1,end-1) = M(end-1,end-1) + nac_weight;
  M(end-2,end-2) = M(end-2,end-2) + nac_weight;


%% Apply boundary conditions

M(1:3,:) = []; %
M(:,1:3) = []; % assume clamped at end.
K(1:3,:) = []; %
K(:,1:3) = []; %




% % Add static boundary condition (weight of nacelle)
% % f_stat1 = (zeros(size(K,1),1));
% % f_stat2 = f_stat1;
% % f_stat2(end) = -nac_weight*9.81;
% % 
% % f_stat1(3:3:end) = -nac_weight*9.81;
% % 
% % xdisp1 = K\f_stat1;
% % xdisp2 = K\f_stat2;







%%
% %ADDING soil stiffness "springs" to the lateral entries in global stiffness matrix.
if soil == 1
run('soil_stiffnessEBbeam.m'); % ONLY ADJUSTED TO N_mono3 = 16,N_mono2 = 10

% monopile 3 lateral entry starts at matrix number K(2,2)  
j = 0;

for i = 2:3:dof*size(soil_der,2)
    
    K(i,i) = K(i,i) + k1(end-j);  % ASSUMING DISPLACEMENT OF SOIL COVERED NODES
j = j + 1;                        % ARE WITHIN THE FIRST SOIL STIFFNESS SEGMENT < 0.02 M 

end

end

%% DAMPING MATRIX
xi = 0.1; %structural damping ratio
 D = calc_dampingmatrix(K,M,xi); % calculates structural damping matrix with rayleigh damping

xi = 0.05; %soildamping ratio
 D2 = calc_dampingmatrix(K,M,xi);

 da = 3*(N_mono3+N_mono2+1);
D = D + D2;
clear D2 xi da

%%
% remove axial dofs as they do not contribute in estimator performance
M(1:3:end,:) = [];
M(:,1:3:end) = [];
D(1:3:end,:) = [];
D(:,1:3:end) = [];
K(1:3:end,:) = [];
K(:,1:3:end) = [];
%% CLEAR UNWANTED VARIABLES
clear A_found A_mono1 A_mono2 A_mono3 A_tower frac1 frac2 frac3 frac4 frac5 I_found I_mono1 I_mono2 I_mono3 I_tower...
    p1 p2 p3 p4 p5 p6 p7 p8 p9 mass_found mass_mono1 mass_mono2 mass_mono3 mass_tower mono1_data mono2_data mono3_data...
    %k1 k2 k3 k4 k_e k_g m_e A d1 d2 




%%
% 
% 
% [eigvec, eigval] = eig(K,M);
% 
% % eigtest
% 
% 
% eigtest = K*eigvec - M*eigvec*eigval;
% 
% 
%     natfreq_hz = sqrt(diag(eigval))/(2*pi);
%     natfreq_hz = sort((real(natfreq_hz)));
%     
%     PlotModeShapes(eigvec,natfreq_hz,fract_length,0);

   % analytical nat freq calc.
   %analyt_natfreq = 1/2*pi*(sqrt(3*E*I(1)/(rho*A(1) + 0.23*tip_mass*L^3)));

% %% STRESS AND STRAIN CALCULATIONS
% 
% % d^2v/dx^2 (twice differntiated shape functions) = B matrix K 
% % eps_xx = du/dx - y*dv/dx
% 
% % Strain will be linerarly dependent on longtitudinal variable x
% % strain varies lineraly across thickness y
% 
% % choosing a point midway on element x = lel(i)/2
% 
% v_disp = 1:3:3*num_el;
% h_disp = 2:3:3*num_el;
% rot_disp = 3:3:3*num_el;
% 
% y = -w_radius.dy/2; % temporary 
% for i = 1:num_el-1
% 
% %x = lel(i);
% x = 0.5*lel(i);
% %x = 0;
% 
% %B = [-6/lel(i)^2 + 12/lel(i)^3*x,-4/lel(i) + 6*x/lel(i)^2,...
%     %6/lel(i)^2 - 12/lel(i)^3*x, -2/lel(i) + 6*x/lel(i)^2];
%     xi = 2*x/lel(i) -1; %natural coordiante of beam element -1|--------0--------|1
%     
% B = (y(i)/lel(i))*[(6*xi)/lel(i),3*xi-1,(-6*xi)/lel(i),3*xi+1];
% 
% res.eps(i) = (res.ax_disp(i+1) - res.ax_disp(i))/lel(i)...
%     - B*[res.tr_disp(i),res.rot_disp(i),res.tr_disp(i+1)...
%     res.rot_disp(i+1)]';
%     
% end
% 
% res.eps = res.eps';
% 
% res.sig = res.eps*E/(10e03)^2;
%                             
% analyt_stress = F_load(end-1)*(L-lel(1))*0.5*w_radius.dy(1)/(10e3^2*I(1))...
%     + F_load(end-2)/(10e3^2*A(1));
% 
