% decide damping coefficients
function D = calc_dampingmatrix(K,M,xi)
D = zeros(size(M,1));
eigval  = eig(K,M);

wn1 = sqrt(eigval(1));
wn2 = sqrt(eigval(2));


m =(wn1/wn2)^2;

alpha = real(1/(1+m)*2*xi*wn1*(1-sqrt(m)));

beta = real((2*xi*wn2 - alpha)/wn2^2);

D = alpha*M + beta*K;

natfrHZ = eigval(1:4);

for i = 1:length(natfrHZ)
natfrHZ(i) = sqrt(natfrHZ(i))/(2*pi);
end

end


