function [zi,A_w,tau_waves]= FEMwaveloads(t,envdata,N_mono1,N_found,D,lel_found,lel_mono1)
% Written by Henrik Paust Spring 2015

%%%%%%%%%%%%%%%%%%% Function objective %%%%%%%%%%%%%%%%%%%%%
% Calculates 1st order inertia wave loads from morison's eq%
% on FEM model from a given wave spectra (default jonswap) %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


w1 = 33/envdata(2); %envdata(2) = Tp

S1 = jonswap(w1,envdata,0); % caluclates the jonswap specter. WAFO built in function
h= 30; % water depth

kt = wave_number_iteration(h,S1.w); % iterates the wave number for freq. wi

A_w = wave_amplitude(S1.S,S1.w); % calculates wave amplitude
zi = zeros(1,length(t));
for i =1:length(t)
for j = 1:271
    zi(i) = A_w(j)*cos(S1.w(j)*t(i) + 2*pi*rand);
    
end
end

depth = 30;

dof = 3;

%Morissons wave force expressed in nodal load vectors for all frequency
%components
morison_forces = nodal_morison_forcesV2(N_mono1,N_found,dof,lel_found,lel_mono1,A_w,S1.w,kt,D);


%Sums the force contribution for each wave component to total wave load per
%time increment


tau_waves = zeros(size(morison_forces,1),length(t));

for j=1:length(t)

    for i = 1:length(S1.w)
    
tau_waves(:,j) = tau_waves(:,j) + morison_forces(:,i)*cos(S1.w(i)*t(j) + 2*pi*rand);
%tau_waves(:,j) = tau_waves(:,j) + morison_forces(:,i);


    end

end

end








