function wave_comp = individ_waveload(t,envdata,N_mono1,N_found,D,lel_found,lel_mono1)

%%%%% calculates each individual wave component contribution
% to load at top transv node

w1 = 33/envdata(2); %envdata(2) = Tp

S1 = jonswap(w1,envdata,0); % caluclates the jonswap specter. WAFO built in function
h= 30; % water depth

kt = wave_number_iteration(h,S1.w); % iterates the wave number for freq. wi

A_w = wave_amplitude(S1.S,S1.w); % calculates wave amplitude


depth = 30;

dof = 3;

%Morissons wave force expressed in nodal load vectors for all frequency
%components
morison_forces = nodal_morison_forces(N_mono1,N_found,dof,lel_found,lel_mono1,A_w,S1.w,kt,D);


%Sums the force contribution for each wave component to total wave load per
%time increment


wave_comp = zeros(size(morison_forces,1),length(t));
for j=1:length(t)
    
    for i = 1:length(S1.w)
    

wave_comp(i,j) = morison_forces(2,i)*cos(S1.w(i)*t(j) + 2*pi*rand);
%tau_waves(:,j) = tau_waves(:,j) + morison_forces(:,i);


    end

end



end

    
