
function tau = nodal_morison_forces(N_mono1,N_found,dof,lel_found,lel_mono1,A_w,omega_waves,kt,Diameter)


%%WAVE LOADS CALUCLATION



%N_mono1  no.el monopart 1;
%N_found  no. el foundation;
%lel_found, lel_mono1  element length  
%D   %diameter structure
%A_w  %wave amplitude wave comp i
%kt  wave number
%dof  degrees of freedom per node;
w = omega_waves; % circ freq waves
Cm = 2; % inertia coefficient
rho_w = 1025; % density sea water


N = N_mono1 + N_found;
tau1_w = zeros(dof*(N+1),1);
tau = zeros(dof*(N+1),length(w));
h = 30; % water depth
lel = lel_found;

for i = 1:length(w)
    q = 1; z = 6;
  
for n = N-1:-1:0
    
    %nl = n*lel_found;
    
    if n*lel_found <= N_found*lel_found
        nl = n*lel_found;
        lel = lel_found;
         
         
    
    else 
        nl = n*lel_mono1;
        lel = lel_mono1;
    end
    
       
           C_i = (pi*rho_w*Diameter^2/4*Cm*0.5*lel*w(i)^2*A_w(i))/sinh(kt(i)*h);
    
    w2 = exp(-nl)*0.25*(6*sinh(kt(i) + h*kt(i) - kt(i)*nl) - 6*sinh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^3 - ...
        (6*cosh(kt(i) + h*kt(i) - kt(i)*nl))/kt(i)^4 + (6*cosh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^4 + ...
        (4*sinh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i);
    
  
    w3 = exp(-nl)*(lel/8)*(4*sinh(kt(i) + h*kt(i) - kt(i)*nl) - 8*sinh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^3 + ...
        (4*cosh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^2 - (6*cosh(kt(i) + h*kt(i) - kt(i)*nl))/kt(i)^4 + ...
        (6*cosh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^4;
    
    w5 = exp(-nl)*0.25*(6*cosh(kt(i) + h*kt(i) - kt(i)*nl))/kt(i)^4 - (6*sinh(kt(i) + h*kt(i) - kt(i)*nl) -...
        6*sinh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^3 - (6*cosh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^4 + ...
        (4*sinh(kt(i) + h*kt(i) - kt(i)*nl))/kt(i);
    
    w6 = exp(-nl)*(lel/8)*(8*sinh(kt(i) + h*kt(i) - kt(i)*nl) - 4*sinh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^3 - ...
        (4*cosh(kt(i) + h*kt(i) - kt(i)*nl))/kt(i)^2 - (6*cosh(kt(i) + h*kt(i) - kt(i)*nl))/kt(i)^4 + ...
        (6*cosh(kt(i) - h*kt(i) + kt(i)*nl))/kt(i)^4;
 
 
 
   
    tau1_el = C_i*[0;w2;w3;0;w5;w6];
    
    
    tau1_w(q:z) = tau1_el;
q = q + 3;
z = z + 3;

end

tau(:,i) = tau1_w;
i = i + 1;
tau(:,1) = 0;
end





