
function tau = nodal_morison_forcesV2(N_mono1,N_found,dof,lel_found,lel_mono1,A_w,omega_waves,kt,Diameter)

%%%% THIS FUNCTION ASSUMES A CONSTANT WAVE FORCE OVER EACH ELEMENT LENGTH.



w = omega_waves; % circ freq waves
Cm = 2; % inertia coefficient
rho_w = 1025; % density sea water


N = N_mono1 + floor(N_found/2);

tau = zeros(dof*(N+1),length(w));
h = 30; % water depth
lel = lel_found;

for i = 1:length(w)
    q = 1; z = 6;
  tau1_w = zeros(dof*(N+1),1);
for n = 0:1:N-1
    
    %nl = n*lel_found;
    
    if n*lel_found <= floor(N_found/2)*lel_found
        nl = n*lel_found;
        lel = lel_found;
         
         
    
    else 
        nl = n*lel_mono1;
        lel = lel_mono1;
    end
    
       
           C_i = (pi*rho_w*Diameter^2/4*Cm*0.5*lel*w(i)^2*A_w(i))/sinh(kt(i)*h);
 
            p = cosh(kt(i)*(-nl + h));
 
 
   
    tau1_el = C_i*(1/2)*p*[0;1;lel/6;0;1;-lel/6];
    
    tau1_w(q:z) = tau1_w(q:z) + tau1_el;
q = q + 3;
z = z + 3;

end

tau(:,i) = tau1_w;

tau(:,1) = 0;
end






