
function tau = waveloadsschultzV3(envdata,t,N_found,N_mono1)


%% calculate jonswap spectrum %%
% Hm0=5;Tp=11; gam=0; sa=0.07; sb=0.09; A=-1;% 
% envdata=[Hm0 Tp gam sa sb A];
w1 = 33/envdata(2); %envdata(2) = Tp
S1 = jonswap(w1,envdata,0);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




rho_w = 1025;
Diameter = 5;
Cm = 2;
lel = 1.33;
g = 9.81;
%%% frequency increment %%%
dw = S1.w(2)-S1.w(1);

Ci = rho_w*(pi*Diameter^2/4)*Cm*lel;

% Empty time series vectors defined before loop
zeta = zeros(length(t),1);
ax = zeros(length(t),1);
F = zeros(length(t),1);
n = length(S1.w);
%Sf = zeros(size(S1.S,1),1);
Sf = 0;
Fetemp = 0;
Tr =zeros(length(t),1);
Rot =zeros(length(t),1);

k = S1.w.^2/g; 
omega =S1.w;
tau = zeros(2*(N_found/2 +N_mono1+1),length(t));
m = 1;
q = 3;
z = 0;
% excitation force spectrum
for j = 1:N_found/2 + N_mono1;
    Tr =zeros(length(t),1);
Rot =zeros(length(t),1);

for i = 1: n
    k = omega(i)^2/g;
    Sf = (Ci*k*g*exp(k*z))^2*S1.S(i);
    
    A_w = sqrt(2*S1.S(i)*dw);
    phase_rand = 2*pi*rand;
    
    Sff = A_w*sqrt(2*Sf*dw)*exp(1i*(phase_rand+pi/2));
    
    
    
Tr = Tr +  Sff*exp(1i*(omega(i)*t))';
Rot = Rot +   lel/6*Sff*exp(1i*(omega(i)*t))';  

end

z = z - 30/15;
tau(m,:) = tau(m,:) + Tr';
tau(q,:) = tau(q,:) + Tr';
m = m+2;
q = q+2;

end

tau = real(tau);

zi = zeros(1,length(t));
for i =1:length(t)
for j = 1:length(S1.w)
    A_w = sqrt(2*S1.S(j)*dw);
    zi(i) = zi(i) + A_w*cos(S1.w(j)*t(i) + 2*pi*(rand-rand));
    
end
end
tau = flipud(tau);
end


