%% SINUSODIAL COMPARISON ESTIMATORS
run('EB_2d_modell.m');
%%%%%% simulation time %%%%%%%%
sim_time = 220;
dt = 0.1;
t = 0:dt:sim_time;
%%%%%%%%%%%%%%%%%%
%%%%%%%%%% remove axial dof %%%%%%%%%%%%%%%%
M(1:3:end,:) = [];
M(:,1:3:end) = [];
D(1:3:end,:) = [];
D(:,1:3:end) = [];
K(1:3:end,:) = [];
K(:,1:3:end) = [];
%%%%%%%% system model

%%
%%
no_input = 1;
b=zeros(size(M,1),no_input); % input for input_state estimator
b(end-1,1) = 1;

%%% OUTPUT VECTOR %%%
N_tot = N_mono3 + N_mono2 + N_mono1 + N_found + N_tower;
 n_meas = 4;
%  C = eye(size(M));
C = zeros(n_meas,size(M,1));
C(1,end-1) = 1;
C(2,2*65+1) = 1;
C(3,2*45+1) = 1;
C(4,2*41+1) = 1;

vnoise = randn(n_meas,length(t));

%% INPUT STATE ESTIMATOR NO.1 

no_modes =10;


%%%%%% ESTIMATOR NO.2 MODEL %%%%
[A_est1,eigVest,G_est,J_est,T_est,eigval_est] = estimator_discrp(M,K,D,C,b,no_modes);
phiest1 = expm(A_est1*dt);
B_est = [zeros(size(phiest1,2)/2,no_input);eigVest'*b];
gamma_est = A_est1\(phiest1 - eye(size(A_est1)))*B_est;



%% TRUE MODEL %%
[eigV eigval] = eig(K,M);
eigval = eig(K,M);
eigV = eigV(:,1:no_modes);

M_mod = eigV'*M*eigV;

K_mod = eigV'*K*eigV;

D_mod = eigV'*D*eigV;

T = [eigV(:,1:no_modes) , zeros(size(eigV(:,1:no_modes)));zeros(size(eigV(:,1:no_modes)))...
    eigV(:,1:no_modes)];

A = [zeros(size(M_mod)) eye(size(M_mod));-K_mod -D_mod];
phi_true = expm(A*dt);
B = [zeros(size(M_mod,1),1);eigV'*b];
gamma_sin = (A)\(phi_true - eye(size(phi_true)))*B;


%OUTPUT FOR TRUE MODEL USED IN ESTIMATR NO.1
J=C*(eigV*eigV')*b;
G = [-C*eigV*K_mod -C*eigV*D_mod];

%OUTPUT FOR TRUE MODEL USED IN ESTIMATOR NO.2
Gta = [-C*eigV*K_mod -C*eigV*D_mod]; % acc output
Gtd = [C*eigV,zeros(size(C*eigV))]; % displacement output


%% ESTIMATOR MODEL NO.2
A_est = [A_est1,[zeros(size(M_mod,1),no_modes);-1*eye(size(M_mod,1),no_modes)];[zeros(no_modes,size(A,2)),-0.1*eye(size(M_mod,1),no_modes)]];

phiest2 = expm(A_est*dt);

% process disturbance matrix for estimator model no.2
Eb = eye(size(phiest2));
Eb(1:2*no_modes,:) = 0;

Ebd = A_est\(phiest2 -eye(size(phiest2)))*Eb;

% OUTPUT MATRICES FOR ESTIMATOR NO.2
[A_est1,eigVest,G_est,J_est,T_est,eigval_est,K_mest,D_mest] = estimator_discrp(M,K,D,C,b,no_modes);
Ged = [C*eigVest,zeros(size(C*eigVest))];
Gea = [-C*eigVest*K_mest -C*eigVest*D_mest];

Hd = [Ged zeros(n_meas,no_modes)];
Ha = [Gea zeros(n_meas,no_modes)];

%% ESTIMATOR VARIABLES 
% ESTIMATOR NO.1
var_R = 10^-5;
R1=var_R*eye(size(n_meas));
Pkk1= 10^-10*eye(size(A));
Q1 = 10^-4*eye(size(A));
%Q1 = 10^4*[gamma_sin*gamma_sin'];
Eb1 = eye(size(phiest1));
Ebd1 = A_est1\(phiest1 -eye(size(phiest1)))*Eb1;



% ESTIMATOR NO.2
var_R = 10^-5;
R2=var_R*eye(size(n_meas));
Q2 = 10^5*eye(size(phiest2));
Pkk2 = 10^-1*eye(size(phiest2));

 Q2(1:no_modes,:) = 10^-2*Q2(1:no_modes,:);
 Q2(1:9,:) = 0;
%% INITALIZATION OF VARYING PLOTTING VARIABLES
xpred1 = zeros(size(A,1),length(t));
xhatp1 = zeros(size(A,1),1);
xest1 = zeros(size(A,1),length(t));
xpred2 = zeros(size(phiest2,1),length(t));
xest2 = zeros(size(phiest2,1),length(t));

xt = zeros(size(A,1),length(t)); %true states 

yinv1 = zeros(n_meas,length(t));
yinv2 = zeros(n_meas,length(t));
y1 = zeros(n_meas,length(t));
y2 = zeros(n_meas,length(t));
ytrue1 = zeros(n_meas,length(t));
ytrue2 = zeros(n_meas,length(t));
taukk = zeros(no_input,length(t));

n = 1;
y_mean1 = zeros(n_meas,1);
std1=zeros(n_meas,1);
y_mean2 = zeros(n_meas,1);
std2=zeros(n_meas,1);

tauw = zeros(1,length(t));

for i = 1:length(t)-1

 tauw(i) = 10^5*sin(0.5*t(i));
 
 
  xt(:,i+1) = phi_true*xt(:,i) + gamma_sin*tauw(i) + 10^1.5*diag(gamma_sin)*randn(size(xt,1),1);
  
   [std1,y_mean1] = stddev_ymeas(y1,n,dt,n_meas); 
   [std2,y_mean2] = stddev_ymeas(y2,n,dt,n_meas); 
n_int1 = diag(std1)*0.05;
 n_int2 = diag(std2)*0.05;
 
    y1(:,i) = G*xt(:,i) + J*tauw(i) +  n_int1*vnoise(:,i);
    y2(:,i) = Gtd*xt(:,i) + n_int2*vnoise(:,i);

   n = n+1; 
   
%%% UPDATE EQUATIONS FOR ESTIMATOR NO.1
Rk = G_est*Pkk1*G_est' + R1;
Mk =inv(J_est'*inv(Rk)*J_est)*J_est'*inv(Rk);
taukk(:,i) = Mk*(y1(:,i) - G_est*xhatp1);
Ppkk = inv((J_est'/(Rk)*J_est));
Lk = Pkk1*G_est'/(Rk);
yinv1 = (J*tauw(i)+n_int1*vnoise(:,i)-J_est*taukk(:,i)+(G*xt(:,i)-G_est*xhatp1));
xpred1(:,i) = xhatp1 + Lk*yinv1;
Pkk1 = Pkk1 - Lk*(Rk - J_est*Ppkk*J_est')*Lk';
Pxp = -Lk*J_est*Ppkk;
xest1(:,i) = phiest1*xpred1(:,i)+ gamma_est*(taukk(:,i));
xhatp1 = xest1(:,i);
Pkk1 = [phiest1 gamma_est]*[Pkk1 Pxp;Pxp' Ppkk]*[phiest1';gamma_est'] + Ebd1*Q1*Ebd1';
%%%%

 %%% UPDATE EQUATIONS FOR ESTIMATOR NO.2
xpred2(:,i+1) = phiest2*xest2(:,i);
S = Hd*Pkk2*Hd' + R2;
L = Pkk2*Hd'/(S);  
Pkk2 = (eye(size(phiest2,1)) - L*Hd)*Pkk2*(eye(size(phiest2,1)) - L*Hd)' + L*R2*L';
yinv2(:,i) = y2(:,i) - Hd*xpred2(:,i+1);
xest2(:,i+1) = xpred2(:,i+1) + L*yinv2(:,i);
Pkk2 = phiest2*Pkk2*phiest2' + Ebd*Q2*Ebd';




end


xtny = zeros(size(M,1)*2,length(t));
xest1ny = zeros(size(M,1)*2,length(t));
xest2ny = zeros(size(M,1)*2,length(t));

for i = 1:length(t)
    

xtny(:,i) = T*xt(:,i);
xest1ny(:,i) = T_est*xest1(:,i);
xest2ny(:,i) = T_est*xest2(1:2*no_modes,i);

end

xtny = xtny';
xest1ny = xest1ny';
xest2ny = xest2ny';



 pplot = 50/dt:5:length(t)-20/dt;
 
n58 = 2*57+1;
n58vel = size(M,1) + 2*57 +1;
n58rot = 2*58;
n58rotvel = size(M,1) + 2*58;
n26 = 2*25+1;
n26vel = size(M,1) + 2*25 +1;
n26rot = 2*26;
n26rotvel = size(M,1) + 2*26;
ttop = size(M,1)-1;
ttopvel = size(xtny,2) -1;



 figure(99)
 subplot(211)
plot(t(pplot),xtny(pplot,n58),'b')
axis tight
hold on
plot(t(pplot),xest1ny(pplot,n58),'r');
plot(t(pplot),xest2ny(pplot,n58),'k','Linewidth',1.1);
axis tight
title('Transversal displacement, node 58','Fontsize',14);
legend('True','Estimate 1','Estimate 2');
ylabel('Displacement [m]','Fontsize',14);
subplot(212)
axis tight
plot(t(pplot),xtny(pplot,n58vel),'b');
hold on
plot(t(pplot),xest1ny(pplot,n58vel),'r');
plot(t(pplot),xest2ny(pplot,n58vel),'k','Linewidth',1.1);
axis tight
%legend('True','Estimate 1','Estimate 2');
xlabel('Time [s]','Fontsize',14);
ylabel('Velocity [m/s]','Fontsize',14);
str=('Transversal velocity, node 58');
title(str,'Fontsize',14);

figure(2)
plot(t(pplot),10^-3*taukk(1,pplot),'r');
hold on
plot(t(pplot),10^-3*tauw(pplot),'b');
axis([50 200 -1.3*10^-3*max(taukk) 1.3*10^-3*max(taukk)]);
title('Estimated and true Sinusodial Force','Fontsize',14);
xlabel('Time [s]','Fontsize',14);
ylabel('Force [kN]','Fontsize',14);
legend('estimate ','true');


%%
restrue = struct();
restrue.tr_disp = xtny(:,1:2:size(M,1));
restrue.rot_disp = xtny(:,2:2:size(M,1));

resest1 = struct();
resest1.tr_disp = xest1ny(:,1:2:size(M,1));
resest1.rot_disp = xest1ny(:,2:2:size(M,1));


resest2 = struct();
resest2.tr_disp = xest2ny(:,1:2:size(M,1));
resest2.rot_disp = xest2ny(:,2:2:size(M,1));


pos = lel_mono1/2; % 1 meter above mudlevel 




el_no = floor(pos/lel_mono1)+N_mono3 + N_mono2;

  
node_val1 = [zeros(length(t),1), restrue.tr_disp(:,el_no),restrue.rot_disp(:,el_no),...
    zeros(length(t),1),restrue.tr_disp(:,el_no+1),restrue.rot_disp(:,el_no+1)];


node_valEst1 = [zeros(length(t),1), resest1.tr_disp(:,el_no),resest1.rot_disp(:,el_no),...
    zeros(length(t),1),resest1.tr_disp(:,el_no+1),resest1.rot_disp(:,el_no+1)];

node_valEst2 = [zeros(length(t),1), resest2.tr_disp(:,el_no),resest2.rot_disp(:,el_no),...
    zeros(length(t),1),resest2.tr_disp(:,el_no+1),resest2.rot_disp(:,el_no+1)];

Vtrue_N10t = zeros(length(t),1);
Mtrue_10Nt = zeros(length(t),1);
Vest_N10t1 = zeros(length(t),1);
Mest_10Nt1 = zeros(length(t),1);
Vest_N10t2 = zeros(length(t),1);
Mest_10Nt2 = zeros(length(t),1);


B_N = zeros(length(t),4);
xi_N = zeros(length(t),1);


for i = 1:length(t)

Vtrue_N10t(i) = linpol_trresponse(pos,lel_mono1,node_val1(i,:));
[Mtrue_10Nt(i),B_N(i,:),xi_N(i)] = bending_moment(node_val1(i,:),pos,lel_mono1,w_radius,I,el_no);

Vest_N10t1(i) = linpol_trresponse(pos,lel_mono1,node_valEst1(i,:));
[Mest_10Nt1(i),B_N(i,:),xi_N(i)] = bending_moment(node_valEst1(i,:),pos,lel_mono1,w_radius,I,el_no);

Vest_N10t2(i) = linpol_trresponse(pos,lel_mono1,node_valEst2(i,:));
[Mest_10Nt2(i),B_N(i,:),xi_N(i)] = bending_moment(node_valEst2(i,:),pos,lel_mono1,w_radius,I,el_no);



end



%%

figure(46)
subplot(311)
plot(t(pplot),xtny(pplot,n26),'b');
axis tight
hold on
plot(t(pplot),xest1ny(pplot,n26),'-r');
plot(t(pplot),xest2ny(pplot,n26),'-k','Linewidth',1.1);
axis tight
legend('True','Estimate 1','Estimate 2');
ylabel('Displacement [m]','Fontsize',14);
%str = sprintf('Tower top displacement from combined loading, Umean = %d [m] tint = %.2f [s]',U_10min,t_int);
str=('Transversal displacement, node 26');
title(str,'Fontsize',14);
subplot(312)
plot(t(pplot),xtny(pplot,n26vel),'b');
axis tight
hold on
plot(t(pplot),xest1ny(pplot,n26vel),'-r');
plot(t(pplot),xest2ny(pplot,n26vel),'-k','Linewidth',1.1);
axis tight
%plot(t(pplot),xpredny(pplot,node26vel),'--k');
ylabel('Velocity [m/s]','Fontsize',14);
%str = sprintf('Tower top displacement from combined loading, Umean = %d [m] tint = %.2f [s]',U_10min,t_int);
str=('Transversal velocity, node 26');
title(str,'Fontsize',14);

subplot(313)
plot(t(pplot),Mtrue_10Nt(pplot)*10^-3,'b');
axis tight
hold on
plot(t(pplot),Mest_10Nt1(pplot)*10^-3,'-r');
plot(t(pplot),Mest_10Nt2(pplot)*10^-3,'-k','Linewidth',1.1);
axis tight
title('Mudline bending moment, node 26','Fontsize',14);
xlabel('Time [s]','Fontsize',14);
ylabel('kNm','Fontsize',14);


figure(26)
subplot(211)
plot(t(pplot),xtny(pplot,n58rot),'b');
axis tight
hold on
plot(t(pplot),xest1ny(pplot,n58rot),'r');
plot(t(pplot),xest2ny(pplot,n58rot),'k');

axis tight
ylabel('[rad]','Fontsize',14);
legend('True','Inp-st-est','Bias-est');
title('Rotation of unmeasured node 58','Fontsize',14);
subplot(212)
plot(t(pplot),xtny(pplot,n58rotvel),'b');
axis tight
hold on
plot(t(pplot),xest1ny(pplot,n58rotvel),'r');
plot(t(pplot),xest2ny(pplot,n58rotvel),'k');
axis tight
title('Rotational velocity of unmeasured node 58','Fontsize',14);
ylabel('[rad/s]','Fontsize',14);
xlabel('Time [s]','Fontsize',14);


