
function [S_kaim, S_white] = kaim_wnoisespectra(U_10min,f_freq,t_int)
%% This function calculates the kaimal spectra used in force simulations 
% The output value S_white is not being used.

h = 115;
l_scale = 600; %length scale l_scale = 20h for h<30 l_scale = 600m for h>30m

%f_freq = (0:0.00001:1)';
S_kaim = zeros(length(f_freq),1);

for i = 1:length(f_freq)
S_kaim(i) = (t_int.^2*U_10min*l_scale)/(1 +(1.5*f_freq(i)*l_scale/U_10min))^(5/3);

end
% format short
% figure(5)
% semilogx(f_freq,S_kaim);
% xlabel('\omega   [rad/s]','Fontsize',14);
% ylabel('S(f)  [m^{2}s]','Fontsize',14);
% str = sprintf('Kaimal spectrum for U_{10min}=%d m/s, t_{int}= %d h =%d m ',U_10min,t_int,h);
% title(str,'Fontsize',14);

format long


%%% SPECTRAL DENSITY OF WHITE NOISE
%spectral density of white noise is constant and equal to the variance
S_white = 1;


