function uw = kaimal_realization(t,turb_int,N_tower,V_10min,uref,zref)

% THIS FUNCTION COMPUTES THE TIME SERIES REALISATION OF THE KAIMAL SPECTRUM
% FOR WIND TURBINE MODEL %


%sim_time = 50;  % sim time;
%dt = 0.1;
dt = t(2)-t(1);
sim_time = t(end);

N = sim_time/dt;       %number of samples

alpha = 0.0001;

%zref =  % reference height
%uref =  % wind speed at zref


%V_10min = uref; %10 min avg. wind speed.
%turb_int = 1/V_10min; % Turbulence intensity

Lt = 115; % height of tower

z = [];
for i = 1:N_tower
    z(i) = Lt/N_tower*i;
end



%fn = linspace(1/T,N/(2*T),N/2);

uw = [];
u_temp = [];
u_tempz = [];
for j = 0:dt:sim_time
    u_tempz = [];
    for i = 1:length(z)
        
        for fn = 1/sim_time:dt:N/(2*sim_time)
        
        u_temp =uref*(z(i)/zref)^alpha + sqrt((2/sim_time)*(turb_int^2*V_10min*20*z(i))/...
            (1 + 1.5*fn*20*z(i)/V_10min)^(5/3))*cos(2*pi*fn - 2*pi*rand);
        
            
        end
        u_tempz = [u_tempz;u_temp];
    end
    uw = [uw, u_tempz];
end
% pfreq = 6;
% figure(765)
% plot(t(1:pfreq:end),uw(end,(1:pfreq:end)),'b');
% xlabel('Time [s]');
% ylabel('wind speed [m/s]');
% %str = sprintf('Realization of Kaimal spectrum:   turbint = %d   U_{mean} = %d m/s',turb_int, V_10min);
% %title(str);
end



