function [uwtot,turb] = kaimal_realizationV2(t,uref,zref,S_kaim,f_freq)
%%
% This function calculates the realization of the kaimal spectra through
% the discrete fourier transform

dt = t(2)-t(1);
sim_time = t(end);

N = sim_time/dt;       %number of samples

alpha = 0.143;

%zref =  % reference height
%uref =  % wind speed at zref

u_w = 0;
%V_10min = uref; %10 min avg. wind speed.

uwtot = zeros(length(t),1);
turb = zeros(length(t),1);
Lt = 115; % height of tower
dk = 1/length(S_kaim);

h = 115;
l_scale = 600; %length scale l_scale = 20h for h<30 l_scale = 600m for h>30m
t_int = 0.2;
U_10min = 10;


for i = 1:length(t)
%u_w = 0;
for fn = 1:length(f_freq)/2
    

u_w = u_w + (sqrt(2*S_kaim(fn)/sim_time)*cos(f_freq(fn)*2*pi*t(i) - 2*pi*rand));

end
uwtot(i) = uref*(Lt/zref)^alpha + u_w;
turb(i) = u_w;
end

end