function tau_3P = loading3P(U_10min,struc_Diameter,N_tower,lel_tower,t,omega_r)


%% 3P LOADING 


rho_a = 1.225;
H = 115;
R = 90; % radius of turbineblade
dof = 3; % DOF per node
beta = 0.27;
C_d = 0.8; % drag coefficient
q = 1; z = 6;


el_start = ceil((H-R)/lel_tower);
num_el = N_tower-el_start;
D = struc_Diameter(length(struc_Diameter)-num_el:end);


nl =linspace(H-R,H,num_el);

i = 1;

for i = 1:length(nl)
    
U = U_10min*((nl(i))/H)^beta;
p = 0.5*C_d*rho_a*D(i)*U^2;
%p = 0.5*C_d*rho_a*D(i)*(uw*exp(decay_fact(i)))^2;

tau_el = p*[0;1;lel_tower/6;0;1;-lel_tower/6];

tau_temp(q:z) = tau_el; 
q = q + 3;
z = z + 3;

end
size(tau_temp)
tau_temp = tau_temp';


%% Generate the 3P loading cycle 
omega = (omega_r/60)*2*pi;
tau_3P=[zeros(dof*el_start,1);tau_temp]*abs(sin(omega*t));


% %% generate the 3P loading cycle = 3omega. NB! ASSUMES a dt=0.5 sec, and omega = 9.6 rpm
% div = 1;
% for i =1:length(t)
%     
%     if mod(t(i),div) > 0 
%         
% tau_3P(:,i) = tau_temp;
% 
%     else tau_3P(:,i) = 0*tau_temp;
%         
%     end
% end
% tau_3P = [zeros(dof*el_start,size(tau_3P,2));tau_3P];
end