function tau_3P = loading3PV2(U_10min,struc_Diameter,N_tower,lel_tower,t,omega_r,uw)


%% 3P LOADING 


rho_a = 1.225;
H = 115;
R = 90; % radius of turbineblade
dof = 3; % DOF per node
beta = 0.27;
C_d = 0.8; % drag coefficient

omega = (omega_r/60)*2*pi;

rps = omega_r/(60); % revolutions per second
rps = 1/rps;
rps2 = rps/3; %blades passing tower per second


el_start = ceil((H-R)/lel_tower);
num_el = N_tower-el_start;
D = struc_Diameter(length(struc_Diameter)-num_el:end);


nl =linspace(H-R,H,num_el);

i = 1;

decay_fact = linspace(0,-0.01,length(nl));
tau_3P = zeros(dof*(N_tower+1),length(t));

for j = 1:length(t)
    tau_temp = zeros(1,dof*(num_el+1));
    q = 1; z = 6;
for i = 1:length(nl)
    
%U = U_10min*((nl(i))/H)^beta;
%p = 0.5*C_d*rho_a*D(i)*U^2;

p = 0.5*C_d*rho_a*D(i)*(uw(j)*exp(decay_fact(i))).^2;

tau_el = p*[0;1;lel_tower/6;0;1;-lel_tower/6];

tau_temp(q:z) = tau_el;
q = q + 3;
z = z + 3;

end
% calculates the loading impulse for the 3P loading function
mrmiagi = 0;
if mod(t(j),round(rps2)) == 0
    mrmiagi = 1;
   
    
else
    mrmiagi = 0;
   
end
tau_temp = tau_temp';

tau_3P(:,j) = [zeros(dof*el_start,1);tau_temp]*mrmiagi;%abs(sin(omega*t(j)));
end

end